//+------------------------------------------------------------------+
//|                                                CArrayRing256.mqh |
//|                               Copyright 2012, Konstantin Gruzdev |
//|                            https://login.mql5.com/ru/users/Lizar |
//|                                             Revision 29 Nov 2012 |
//+------------------------------------------------------------------+
#property copyright   "Copyright 2012, Konstantin Gruzdev"
#property link        "https://login.mql5.com/ru/users/Lizar"

//+------------------------------------------------------------------+
//| Class CArrayRing256                                              |
//| Appointment:              |
//|  ,             |
//|   .              |
//|       :                |
//|   -  (256 )    |
//|   -                                 |
//| Link: http://www.mql5.com/ru/code/1379                           |
//+------------------------------------------------------------------+
class CArrayRing256
  {
private:
   double            m_data[UCHAR_MAX+1];             //   
   uchar             m_last_pos;                      //    
public:
                     CArrayRing256(): m_last_pos(0)   { Init(EMPTY_VALUE);                         }
   //---   :
   void              Init(double volue=EMPTY_VALUE)   { ArrayFill(m_data,0,Size(),volue);          }               
   //---    :
   int               Size()                           { return (ArraySize(m_data));                }
   //---      :
   void              Add(const double element)        { m_data[++m_last_pos]=element;              } 
   //---       :
   double            At(const uchar index) const      { return(m_data[uchar(m_last_pos-index)]);   }
   double operator   [](const uchar index) const      { return(At(index));                         }
   //---        :
   double            Last() const                     { return(m_data[m_last_pos]);                } 
   //---       :
   void              Last(const double element)       { m_data[m_last_pos]=element;                }  
   //---       :
   void              Update(const double element,
                            const uchar index=0)      { m_data[uchar(m_last_pos-index)]=element;   }  
  };